<template>
    <div class="app-container">
        <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
            <el-form-item label="标题" prop="title">
                <el-input v-model="queryParams.title" placeholder="请输入标题" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item>
                <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
                <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
            <el-col :span="1.5">
                <el-button type="primary" plain icon="Plus" @click="handleAdd">新增</el-button>
            </el-col>
            <el-col :span="1.5">
                <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate">修改</el-button>
            </el-col>
            <el-col :span="1.5">
                <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete">删除</el-button>
            </el-col>
            <el-col :span="1.5">
                <el-button type="warning" plain icon="Download" :disabled="multiple" @click="handleExport">导出</el-button>
            </el-col>
            <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <el-table v-loading="loading" :data="culturalList" @selection-change="handleSelectionChange">
            <el-table-column type="selection" width="55" align="center" />
            <el-table-column label="id" width="120" align="center" prop="id" />
            <!-- <el-table-column label="用户id" align="center" prop="userId" /> -->
            <el-table-column label="标题" width="180" align="center" prop="title" />
            <el-table-column label="展厅" width="180" align="center" prop="app.title" />
            <el-table-column label="类型" width="140" align="center" prop="type.title" />
            <!-- <el-table-column label="状态" align="center" prop="status" /> -->
            <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
                <template #default="scope">
                    <el-button link type="primary" icon="Connection" @click="handleQrCode(scope.row)">查看二维码</el-button>
                    <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)">修改</el-button>
                    <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)">删除</el-button>
                </template>
            </el-table-column>
        </el-table>

        <pagination
            v-show="total > 0"
            :total="total"
            v-model:page="queryParams.pageNum"
            v-model:limit="queryParams.pageSize"
            @pagination="getList"
        />

        <!-- 添加或修改文创产品对话框 -->
        <el-dialog :title="title" v-model="open" width="500px" append-to-body>
            <el-form ref="culturalRef" :model="form" :rules="rules" label-width="80px">
                <el-form-item label="标题" prop="title">
                    <el-input v-model="form.title" placeholder="请输入标题" />
                </el-form-item>
                <el-form-item label="展厅" prop="appId">
                    <el-select v-model="form.appId" placeholder="请选择展厅" size="large" style="width: 240px">
                        <el-option v-for="item in appList" :key="item.id" :label="item.title" :value="item.id" />
                    </el-select>
                </el-form-item>
                <el-form-item label="类型" prop="typeId">
                    <el-select v-model="form.typeId" placeholder="请选择文创产品类型" size="large" style="width: 240px">
                        <el-option v-for="item in typeList" :key="item.id" :label="item.title" :value="item.id" />
                    </el-select>
                </el-form-item>
            </el-form>
            <template #footer>
                <div class="dialog-footer">
                    <el-button type="primary" @click="submitForm">确 定</el-button>
                    <el-button @click="cancel">取 消</el-button>
                </div>
            </template>
        </el-dialog>

        <!-- 二维码 -->
        <el-dialog :title="qrTitle" v-model="openQrCode" width="500px" center append-to-body>
            <div class="qrcode" style="margin-left: 100px">
                <vue-qr :text="qrcodeVal" :size="240"></vue-qr>
            </div>
            <template #footer>
                <div class="dialog-footer">
                    <el-button type="primary" @click="downloadQr">下 载</el-button>
                    <el-button @click="cancelQrCode">取 消</el-button>
                </div>
            </template>
        </el-dialog>
    </div>
</template>

<script setup name="Cultural">
// import vueQr from 'vue-qr/src/packages/vue-qr.vue'

import { listCultural, getCultural, exportCultural, delCultural, addCultural, updateCultural } from '@/api/culturals/cultural'
import { listCulturalType } from '@/api/culturals/culturalType'
import { listApp } from '@/api/vrone/app'

const { proxy } = getCurrentInstance()

const culturalList = ref([])
const appList = ref([])
const typeList = ref([])
const open = ref(false)
const openQrCode = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref('')
const qrTitle = ref('')
const qrcodeVal = ref('http://img.han-zhi.net/wlcd/pv/index.html')

const data = reactive({
    form: {},
    queryParams: {
        pageNum: 1,
        pageSize: 10,
        userId: null,
        appId: null,
        title: null,
        type: null,
        status: null
    },
    rules: {}
})

const { queryParams, form, rules } = toRefs(data)

/** 查询文创产品列表 */
function getList() {
    loading.value = true
    listCultural(queryParams.value).then(response => {
        culturalList.value = response.rows
        total.value = response.total
        loading.value = false
    })
}

/** 查询展厅列表 */
function getAppList() {
    listApp().then(response => {
        appList.value = response.data
    })
}

/** 查询文创产品类别列表 */
function getTypeList() {
    listCulturalType().then(response => {
        typeList.value = response.rows
    })
}

// 取消按钮
function cancel() {
    open.value = false
    reset()
}

// 表单重置
function reset() {
    form.value = {
        id: null,
        userId: null,
        app: null,
        appId: null,
        title: null,
        type: null,
        typeId: null,
        status: null,
        createTime: null,
        createBy: null,
        updateTime: null,
        updateBy: null
    }
    appList.value = []
    typeList.value = []
    proxy.resetForm('culturalRef')
}

/** 搜索按钮操作 */
function handleQuery() {
    queryParams.value.pageNum = 1
    getList()
}

/** 重置按钮操作 */
function resetQuery() {
    proxy.resetForm('queryRef')
    handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
    ids.value = selection.map(item => item.id)
    single.value = selection.length != 1
    multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
    reset()
    getAppList()
    getTypeList()
    open.value = true
    title.value = '添加文创产品'
}

/** 修改按钮操作 */
function handleUpdate(row) {
    reset()
    const _id = row.id || ids.value
    getCultural(_id).then(response => {
        form.value = response.data
        open.value = true
        title.value = '修改文创产品'
        getAppList()
        getTypeList()
    })
}

/** 二维码按钮操作 */
function handleQrCode(row) {
    qrTitle.value = row.title + '二维码'
    openQrCode.value = true
}

function cancelQrCode() {
    qrTitle.value = ''
    openQrCode.value = false
}

function downloadQr() {
    let myImg = document.querySelector('.qrcode img')
    let url = myImg.src
    let link = document.createElement('a')
    link.href = url
    link.download = qrTitle.value //下载图名称
    link.click()
    proxy.$modal.msgSuccess('下载成功')
    openQrCode.value = false
}

/** 提交按钮 */
function submitForm() {
    proxy.$refs['culturalRef'].validate(valid => {
        if (valid) {
            if (form.value.id != null) {
                updateCultural(form.value).then(response => {
                    proxy.$modal.msgSuccess('修改成功')
                    open.value = false
                    getList()
                })
            } else {
                addCultural(form.value).then(response => {
                    proxy.$modal.msgSuccess('新增成功')
                    open.value = false
                    getList()
                })
            }
        }
    })
}

/** 导出二维码excel按钮操作 */
function handleExport(row) {
    const _ids = row.id || ids.value
    exportCultural({ ids: _ids })
        .then(response => {
            const url = window.URL.createObjectURL(new Blob([response]))
            const link = document.createElement('a')
            link.href = url
            link.setAttribute('download', `culturalLog_${new Date().getTime()}.xlsx`)
            document.body.appendChild(link)
            link.click()
            proxy.$modal.msgSuccess('导出成功')
        })
        .catch(error => {
            console.error('导出失败:', error)
            proxy.$modal.msgError('导出失败')
        })
}

/** 删除按钮操作 */
function handleDelete(row) {
    const _ids = row.id || ids.value
    proxy.$modal
        .confirm('是否确认删除文创产品编号为"' + _ids + '"的数据项？')
        .then(function () {
            return delCultural(_ids)
        })
        .then(() => {
            getList()
            proxy.$modal.msgSuccess('删除成功')
        })
        .catch(() => {})
}

getList()
</script>
